<template>
  <div
    class="form-group form-check d-flex my-1"
    :class="{ 'align-items-center': isEditingName }"
  >
    <input
      type="checkbox"
      class="form-check-input"
      :id="elementId"
      @input="updateTodo"
    />
    <label
      v-if="!isEditingName"
      @click="isEditingName = true"
      class="form-check-label flex-grow-1"
      :for="elementId"
      >{{ name }}</label
    >
    <input
      v-if="isEditingName"
      @blur="isEditingName = false"
      class="form-control"
      type="text"
      v-model="name"
      @input="updateTodo"
    />
    <span
      class="bg-danger delete-button d-flex align-items-center justify-content-center rounded-circle"
      type="button"
      @click="deleteTodo"
    >
      <app-icon class="text-light" icon="trash" size="xs" />
    </span>
  </div>
</template>

<script lang="ts">
import { Todo } from "@/core/database";
import { defineComponent, PropType } from "vue";
export default defineComponent({
  emits: ["update", "delete"],
  props: {
    todo: {
      type: Object as PropType<Todo>,
      required: true,
    },
  },
  created() {
    this.name = this.todo.name;
    this.done = this.todo.done;
  },
  computed: {
    elementId(): string {
      return `todo-item-${this.todo.id}`;
    },
  },
  data() {
    return {
      name: "",
      done: false,
      isEditingName: false,
    };
  },
  methods: {
    updateTodo() {
      const updatedTodo = new Todo(
        this.todo.id,
        this.name,
        this.todo.cardId,
        this.done
      );
      this.$emit("update", updatedTodo);
    },
    deleteTodo() {
      this.$emit("delete", this.todo);
    },
  },
});
</script>

<style scoped>
.delete-button {
  height: 1.5rem;
  width: 1.5rem;
  transition: transform ease-in 200ms;
}
.delete-button:hover {
  transform: scale(1.2);
}
</style>
